********************************************************************************
* air.gms
********************************************************************************

*Reading sets and parameter values from gdx file
$Gdxin air.gdx
Set        v_air(v_all)          Set of variables related to air supply;
$load v_air
Sets       p_feed(iv)            Feed pressure
           T_airfeed(iv)         Air feed temperature
           flow_ATRair(v_air)    Air flowrates to the ATR
           p_ATRair(v_air)       Pressure of the air flows to the ATR
           T_ATRair(v_air)       Temperature of the air flows to the ATR;
$load p_feed, T_airfeed, flow_ATRair, T_ATRair, p_ATRair
Sets       flow_ATRair_2nd(flow_ATRair)            air flows into the ATR
           ATRair(p_ATRair, T_ATRair, flow_ATRair) (connecting variables);
Parameters ATR_air(v)                    stoichiometry for reforming reactions
           p_and_T(p_ATRair, T_ATRair)   (used for connecting cariables)
           airflow                       flow rate through main compressor;
$load ATRair, flow_ATRair_2nd, ATR_air, p_and_T,
$load airflow

$Gdxin
*End of reading

Equations
         airbalance                     determining the amount of ATR air needed
         ATRpressure(p_ATRair, p_feed)  ATR pressure=air compression pressure
         airtemperaturesum(T_airfeed)   mixing temperature
         AF                             balance for air flow from main compr.;

airbalance .. sum(flow_ATRair, x(flow_ATRair)) =e=
         sum(v$(ATR_air(v) <> 0), x(v)*ATR_air(v));
ATRpressure(p_ATRair, p_feed).. x(p_ATRair) =e=
         .5*(high(p_feed)+low(p_feed))+(high(p_feed)-low(p_feed))*x(p_feed);
airtemperaturesum(T_airfeed) .. sum(ATRair(p_ATRair, T_ATRair, flow_ATRair),
         tempscale*x(T_ATRair) * x(flow_ATRair)) =e= (273.15+.5*(high(T_airfeed)
         +low(T_airfeed))+(high(T_airfeed)-low(T_airfeed))*x(T_airfeed)) *
         sum(flow_ATRair, x(flow_ATRair));
AF.. sum(comb_airflow,x(comb_airflow))+sum(flow_ATRair_2nd,x(flow_ATRair_2nd))
         =e= airflow;
