%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% air.m - setting parameters and sets related to air distribution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Functions and scripts used:
% GDXMRW:       writegdx.m      writing data to gdx file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% The amount of air needed in the ATR per mass flow of CO2, CO and H2 in 
% the cooled syngas
ATR_air=zeros(v,1);
ATR_air(CS_CO2)=2/M.CO2;
ATR_air(CS_CO)=1.5/M.CO;
ATR_air(CS_H2)=-.5/M.H2;
ATR_air=ATR_air*M.O2/airO2mass;

% The amount of air compressed in the main (large-scale) air compressor
airflow=640*3600/flowscale;

% Air related variables
v_air=union(flow_ATRair_set, [p_ATRair_set; T_ATRair_set]);

% Writing data to file
writegdx('air.gdx', ...
    'set',       'v_air',       v_air, ...
    'set',       'p_feed',      feedpressure, ...
    'set',       'T_airfeed',   airtemp, ...
    'set',       'flow_ATRair', flow_ATRair_set, ...
    'set',       'flow_ATRair_2nd', flow_ATRair_2nd, ...
    'set',       'p_ATRair',    p_ATRair_set, ...
    'set',       'T_ATRair',    T_ATRair_set, ...
    'set',       'ATRair',      [p_ATRair_set T_ATRair_set flow_ATRair_set],...
    'parameter', 'p_and_T',     [p_ATRair_set, T_ATRair_set, ones(2,1)],...
    'parameter', 'ATR_air',     [v_set ATR_air], ...
    'parameter', 'airflow',     airflow, ...
    uels);