
try
    filetoreadfrom='hrsgopt.gdx';
    T_in=sp2full(readgdx(filetoreadfrom,'Tin'),'parameter')';
    T_out=sp2full(readgdx(filetoreadfrom,'Tout'),'parameter')';
    mCp=sp2full(readgdx(filetoreadfrom,'mCp'),'parameter')';
    HRAT=sp2full(readgdx(filetoreadfrom,'HRAT'),'parameter');
    cost=sp2full(readgdx(filetoreadfrom,'z'),'parameter');
    if length(mCp)<streams(st)
        mCp(streams(st))=0;
    end
catch
    disp(['COULD NOT READ FROM ' filetoreadfrom])
end

if length(T_in_up)<streams(st)
    T_in_up=sp2full(T_in_up,'parameter')';
    T_in_lo=sp2full(T_in_lo,'parameter')';
    T_out_lo=sp2full(T_out_lo,'parameter')';
    flowcost=sp2full(flowcost,'parameter')';
    file='ircc.gdx';
    if length(T_in)<streams(st)
        T_in(streams(st))=0;
    end
    if length(T_in_lo)<streams(st)
        T_in_lo(streams(st))=0;
    end
    if length(T_in_up)<streams(st)
        T_in_up(streams(st))=0;
    end
    if length(T_out)<streams(st)
        T_out(streams(st))=0;
    end
    if length(T_out_lo)<streams(st)
        T_out_lo(streams(st))=0;
    end
    if length(flowcost)<streams(st)
        flowcost(streams(st))=0;
    end
end
T_out(iso)=T_in(iso);
T_out_lo(iso)=T_in_lo(iso);

if sum([T_in>T_in_up T_out(noniso)<T_out_lo(noniso)])
    disp('BOUNDS NOT SATISFIED!')
end

T_in(allcold)=T_in(allcold)+HRAT;
T_out(cold)=T_out(cold)+HRAT;
T=unique([T_in(streams) T_out(noniso)]);
t=length(T)-1;
Qcold=zeros(1,t);
Qhot=Qcold;
Qisocold=Qcold;
Qisohot=Qisocold;
for i=1:t;
    Qcold(i)=sum((T_in(cold)<=T(i)).*(T_out(cold)>=T(i+1))*mCp(cold)')*(T(i+1)-T(i));
    Qhot(i)=sum((T_in(hot)>=T(i+1)).*(T_out(hot)<=T(i))*mCp(hot)'*(T(i+1)-T(i)));
    Qisocold(i)=sum((T_in(isocold)==T(i))*mCp(isocold)');
    Qisohot(i)=sum((T_in(isohot)==T(i))*mCp(isohot)');    
end
demand=Qhot-Qcold+Qisohot-Qisocold;
Qisocold(t+1)=sum((T_in(isocold)==T(t+1))*mCp(isocold)');
Qisohot(t+1)=sum((T_in(isohot)==T(t+1))*mCp(isohot)');   
demand(t+1)=Qisohot(t+1)-Qisocold(t+1);
for i=t:-1:1
    demand(i)=demand(i)+demand(i+1);
end
[Q_H, p]=max([-demand 0]);
Q_C=(T_in(noniso)-T_out(noniso))*mCp(noniso)'+Q_H + sum(mCp(isohot)) - sum(mCp(isocold));
T_pinch=[T(p) T(p)-HRAT];
Q=demand+Q_H;
demand=Qhot-Qcold;

coldcomposite=zeros(1,2*t+2);
coldcomposite(1)=Q_C;
hotcomposite=zeros(1,2*t+2);
Temps=zeros(1,2*t+2);
for i=1:t
    Q(2*i)=Q(2*i-1)+Qisocold(i)-Qisohot(i);
    Temps(2*i-1)=T(i);
    Q(2*i+1)=Q(2*i)+Qcold(i)-Qhot(i);
    Temps(2*i)=T(i);
    coldcomposite(2*i)=coldcomposite(2*i-1)+Qisocold(i);
    coldcomposite(2*i+1)=coldcomposite(2*i)+Qcold(i);
    hotcomposite(2*i)=hotcomposite(2*i-1)+Qisohot(i);
    hotcomposite(2*i+1)=hotcomposite(2*i)+Qhot(i);
end
Temps(2*t+1)=T(t+1);
Q(2*t+2)=Q(2*t+1)+Qisocold(t+1)-Qisohot(t+1);
coldcomposite(2*t+2)=coldcomposite(2*t+1)+Qisocold(t+1);
hotcomposite(2*t+2)=coldcomposite(2*t+1)+Qisohot(t+1);
Temps(2*t+2)=T(t+1);

grandcomposite=coldcomposite-hotcomposite;

figure(1)
plot(grandcomposite,Temps-.5*HRAT,'o-')
xlabel('Q [MW]')
ylabel('T [^{o}C]')
xlim([min(grandcomposite) max(grandcomposite)])
figure(2)
frmtc='b-';
frmth='r-';
evalstring='plot(';
for i=2:2*t+2;
    if coldcomposite(i)~=coldcomposite(i-1)
        evalstring=[evalstring '[' ...
            num2str(coldcomposite(i-1)) ',' num2str(coldcomposite(i)) ...
            '],[' num2str(Temps(i-1)-HRAT) ',' num2str(Temps(i)-HRAT) ...
            '],frmtc,'];
    end
    if hotcomposite(i)~=hotcomposite(i-1)
        evalstring=[evalstring '[' ...
            num2str(hotcomposite(i-1)) ',' num2str(hotcomposite(i)) ...
            '],[' num2str(Temps(i-1)) ',' num2str(Temps(i)) '],frmth,'];
    end
end
evalstring(length(evalstring))=')';
eval(evalstring)
xlabel('Q [MW]')
ylabel('T [^{o}C]')
xlim([min([coldcomposite hotcomposite]) max([coldcomposite hotcomposite])])
            

ho=length(hot);
co=length(cold);
hc=max([ho co]);
Qcold=zeros(hc,t);
Qhot=Qcold;
for i=1:t;
    for j=1:co
        Qcold(j,i)=(T_in(cold(j))<=T(i)).*(T_out(cold(j))>=T(i+1))*mCp(cold(j))*(T(i+1)-T(i));
    end
    for j=1:ho
        Qhot(j,i)=(T_in(hot(j))>=T(i+1)).*(T_out(hot(j))<=T(i))*mCp(hot(j))*(T(i+1)-T(i));
    end
end
T_in(allcold)=T_in(allcold)-HRAT;
T_out(cold)=T_out(cold)-HRAT;

frmt='%9s'; frmtl='%-9s';
bl=9;
disp(['Q_H = ' num2str(Q_H)])
disp([num2str(Qisohot(t+1)) blanks(2*bl+7) num2str(-Qisocold(t+1))])
if t+1==p
    disp('         Pinch')
end
for i=t:-1:1
    disp(['   ' sprintf(frmt,num2str(T(i+1))) '_________' sprintf(frmtl,num2str(T(i+1)-HRAT))])
    disp([blanks(bl+2) '|' sprintf(frmt,num2str(demand(i))) '|'])
    for j=1:hc
        disp([sprintf(frmt,num2str(Qhot(j,i))) ' -|' blanks(bl) '|- ' sprintf(frmtl,num2str(Qcold(j,i)))])
    end
    disp([blanks(bl+2) '|_________|'])
    disp([num2str(Qisohot(i)) blanks(2*bl+7) num2str(-Qisocold(i))])
    if i==p
        disp([blanks(bl) 'Pinch'])
    end
end
disp(['   ' sprintf(frmt,num2str(T(1))) blanks(bl) sprintf(frmtl,num2str(T(1)-HRAT))])
disp(['Q_C = ' num2str(Q_C)])

Qflow=zeros(1,st);
Qflow(noniso)=(T_in(noniso)-T_out(noniso)).*mCp(noniso);
Qflow(isohot) =mCp(isohot);
Qflow(isocold)=-mCp(isocold);

frmt='%11s %10.4g %10.4g %10.4g %12.4g %10.4g %10.4g \n';
disp('     Stream       T_in       T_out        mCp     Qflow')

for i=streams'
    fprintf(frmt, uels{i}, T_in(i), T_out(i), mCp(i), Qflow(i), T_in_up(i)-T_in(i), T_out(i)-T_out_lo(i));
end
disp(['Cost: ' num2str(mCp*flowcost'+Q_H*Q_Hcost+Q_C*Q_Ccost) ' (calculated from "optimal" stream data)'])
if strncmp('hrsg', file, 4)
    disp(['Cost: ' num2str(cost) ' (optimal objective value from ' file ')'])
end


frmt='%11s & %10.4g & %10.4g & %10.4g & %12.4g\\\\ \n';
disp('     Stream    &  t$_{IN}$ &    t$_{OUT}$ &  q     &  Q \\ \hline')

for i=streams'
    fprintf(frmt, uels{i}, T_in(i), T_out(i), mCp(i), Qflow(i));
end
disp(['Cost: ' num2str(mCp*flowcost'+Q_H*Q_Hcost+Q_C*Q_Ccost) ' (calculated from "optimal" stream data)'])
if strncmp('hrsg', file, 4)
    disp(['Cost: ' num2str(cost) ' (optimal objective value from ' file ')'])
end