********************************************************************************
* combustion.gms
********************************************************************************

*Reading sets and parameter values from gdx file
$Gdxin combustion.gdx
Set              v_comb(v_all)           Set of variables related to combustion;
$load v_comb
Sets
                 exhcomp(v_comb)         The componets in the exhaust
                 comb_airflow(v_comb)    Air flowrate to the combustor;
$load exhcomp, comb_airflow
Parameter        combreaction(v,exhcomp) Reaction stoichiometry
                 air(exhcomp)            Air composition
                 q_comb_air              Heating of air to combustion temp.(TIT)
                 LHV(v)                  Lower heating values
                 CpDT(exhcomp)           Heating of combustion products to TIT
                 tempscale               Scaling factor for some temperatures;
$load combreaction, air, q_comb_air, LHV, CpDT
$load tempscale
$Gdxin
*End of reading

Equations
         combustion(exhcomp, comb_airflow) combustion reactions
         heatbalance(comb_airflow)         heat balance to determine air excess;

heatbalance(comb_airflow)    ..
         sum(exhcomp, CpDT(exhcomp)*(x(exhcomp)-air(exhcomp)*x(comb_airflow)) +
         air(exhcomp)*x(comb_airflow)*q_comb_air) =e= sum(v, LHV(v) * x(v));
combustion(exhcomp, comb_airflow) .. x(exhcomp) =e=
         sum(v$(combreaction(v,exhcomp)<>0), combreaction(v,exhcomp)*x(v)) +
         air(exhcomp)*x(comb_airflow);
