%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% getsolution.m - reading the solution of the model from irccoptimum.gdx
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Functions and scripts used:
% GDXMRW:   readgdx.m       reading data from.gdx files
%           sp2full.m       changing matrix from 'sparse' to 'full' format
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Specifying the file to read from
filetoreadfrom='irccoptimum.gdx';

% Reading the solution from a gdx file produced by GAMS
x_opt=readgdx(filetoreadfrom,'x_opt');
x_opt(:,1)=v_all(x_opt(:,1));
x_opt=sp2full(x_opt,'parameter')';

try
    info(1)=sp2full(readgdx(filetoreadfrom,'z_opt'),'parameter')';
catch
    disp('No information about objective')
    info(1)=NaN;
end
try
info(2)=sp2full(readgdx(filetoreadfrom,'exectime'),'parameter')';
catch
    disp('No information about execution time')
    info(2)=-5;
end
try
    info(3)=sp2full(readgdx(filetoreadfrom,'iterations'),'parameter')';
catch
    disp('No information about iterations')
    info(3)=-5;
end
try
    info(4)=sp2full(readgdx(filetoreadfrom,'modelstatus'),'parameter')';
catch
    disp('No information about model status')
    info(4)=-5;
end

x_opt(length(x_opt)+1:length(uels))=0;
%Saving the solution if the model found one
if info(4)==1 || info(4)==2
    tid=datestr(now);
    save('A_matrix', 'x_opt', 'tid', '-append')
end