function sample=sampling(n, m)
% SAMPLING(n,m) returns a [n x m] matrix with rows representing different
% combinations of numbers (a Latin Hypercube)
    
    % Initializing
    M=cell(m,1);
    for j=1:m
        % List of unused intervals for each variable
        M{j}=1:n;
    end
    sample=zeros(n,m);
    
    for i=1:n
        for j=1:m
            % Picking an unused interval for each sample
            sample(i,j)=M{j}(ceil(rand*(n-i+1)));
            % Removing the picked interval from the list of unused ones
            M{j}=setdiff(M{j},sample(i,j));
        end
    end  
return
    