filepath='';
inputfile='flowsheet_mal.svg';
destination='flowsheet_new';
filename=['flowsheet_' 'opt' '.svg'];
flowsheet=fileread([filepath inputfile]);

a='<!-- insert text here -->';
N_FS=length(flowsheet);
for i=1:N_FS-24
    if strcmp(flowsheet(i:i+24),a)
        flekk=i+27;
    end
end
i=5;

solutiontext='';

navn=uels;

verdi=x_opt;
verdi(mCp_refprod)=verdi(mCp_refprod).*(T_refprod - verdi(HTStemp));
verdi(mCp_HTSprod)=verdi(mCp_HTSprod).*(verdi(HTStemp2) - verdi(LTStemp));
verdi(mCp_LTSprod)=verdi(mCp_LTSprod).*(verdi(LTStemp2) - T_WRfeed);
verdi(mCp_GTfuel)=verdi(mCp_GTfuel).*(200-verdi(GTfueltemp));
verdi(massflows)=verdi(massflows)*1000;
verdi(outlettemp_set)=verdi(outlettemp_set)*tempscale-C2K;
verdi(feedflow)=verdi(feedflow)*CH4_in;

unit=cell(1,length(uels));
unit(temperatures)={'C'};
unit(massflows)={'kg/s'};
unit(energyflows)={'MW'};
unit(pressures)={'bar'};
unit(S2C)={'(S2C)'};

frmt=cell(1,length(uels));
frmt(temperatures)={'%3.0f'};
frmt(massflows)={'%3.0f'};
frmt(energyflows)={'%3.0f'};
frmt(pressures)={'%2.1f'};

CCU_flow=sum(verdi(CCU_set));
exh_flow=sum(verdi(exhaust_set));
verdi(exhaust_set)=verdi(exhaust_set)/exh_flow*100;
verdi(CCU_set)=verdi(CCU_set)/CCU_flow*100;
for i=[exhaust_set' CCU_set]
    unit{i}=['% ' navn{i}(5:length(navn{i}))];
end
frmt([exhaust_set' CCU_set])={'%2.2g'};

for i=v_all';
    solutiontext=[solutiontext '<text id="' navn{i} '">' num2str(verdi(i),frmt{i}) unit{i} '</text>' char(10)];
end
LPsteamflow=mCp(LPB)/q_LPB;
solutiontext=[solutiontext '<text id="LPsteamflow">' num2str(LPsteamflow,frmt{HPsteamflow}) unit{HPsteamflow} '</text>' char(10)];
solutiontext=[solutiontext '<text id="W_LP">' num2str(W_LP,frmt{W_HPturb}) unit{W_HPturb} '</text>' char(10)];


flowsheet=[flowsheet(1:flekk) solutiontext flowsheet(flekk+1:N_FS)];

fid=fopen([destination '.svg'],'w');
fprintf(fid,'%s',flowsheet);
fclose(fid);
inkscapepath='';
dos(['"' 'inkscape" -f ' destination '.svg -A ' destination '.pdf --export-area-drawing'])